/*------------------------------------------------*/
/* 01glfw/freeglut/main.c                         */

#include <stdlib.h>
#include <GL/freeglut.h>
#include <stdio.h>

#define GLUT_KEY_ESCAPE '\x1B'

void display(void);
void key_callback(unsigned char key, int x, int y);
void mouse_button_callback(int button, int state, int x, int y);


int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitContextVersion(3, 3);
	glutInitContextProfile(GLUT_CORE_PROFILE);
	glutInitWindowSize(600, 450);
	glutCreateWindow("Hello World");
	glutKeyboardFunc(&key_callback);
	glutMouseFunc(&mouse_button_callback);
	glutDisplayFunc(&display);
	printf("%s\n", glGetString(GL_VERSION));
	glutMainLoop();

	return EXIT_SUCCESS;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glColor3f(1.0f, 0.0f, 0.0f);

	glBegin(GL_POLYGON);
	glVertex2f(-0.5f, -0.5f);
	glVertex2f(0.5f, -0.5f);
	glVertex2f(0.5f, 0.5f);
	glVertex2f(-0.5f, 0.5f);
	glEnd();

	glFlush();
}

void key_callback(unsigned char key, int x, int y)
{
	switch (key)
	{
	case GLUT_KEY_ESCAPE:
		printf("Byla stisknuta klavesa Escape.\n");
		exit(EXIT_SUCCESS);
		break;
	}
}

void mouse_button_callback(int button, int state, int x, int y)
{
	printf("Click na pozici [%i, %i]\n", x, y);
	if (button == GLUT_RIGHT_BUTTON) {
		printf("Stisk nebo uvolneni praveho tlacitka.\n");
	}
	if (state == GLUT_DOWN) {
		printf("Stisk tlacitka\n");
	}
	if (state == GLUT_UP) {
		printf("Uvolneni tlacitka\n");
	}
}
/*------------------------------------------------*/
