extern mat4x4 rotationMatrix;
extern quat rotationQuat;

void updateAngles(GLfloat _xAngle, GLfloat _yAngle) {
	quat xQuat, yQuat, tmpQuat;

	vec3 axis = {1,0,0};
	quat_rotate(xQuat, _xAngle, axis);
	tmpQuat[0] = rotationQuat[0];
	tmpQuat[1] = rotationQuat[1];
	tmpQuat[2] = rotationQuat[2];
	tmpQuat[3] = rotationQuat[3];
	quat_mul(rotationQuat, tmpQuat, xQuat);

	axis[0] = 0;
	axis[1] = 1;
	quat_rotate(yQuat, _yAngle, axis);
	tmpQuat[0] = rotationQuat[0];
	tmpQuat[1] = rotationQuat[1];
	tmpQuat[2] = rotationQuat[2];
	tmpQuat[3] = rotationQuat[3];
	quat_mul(rotationQuat, tmpQuat, yQuat);

	mat4x4_from_quat(rotationMatrix, rotationQuat);
}
