#version 330 core
layout (location = 0) in vec3 vertexPosition;
layout (location = 1) in vec3 vertexNormal;
layout (location = 2) in vec2 textureCoord;

uniform mat4 uMVMatrix;
uniform mat4 uPMatrix;
uniform mat3 uNMatrix;
 
out vec4 mvPosition;
out vec4 vColor;
out vec3 transformedNormal;
out vec2 texCoord;

void main(void) {
    mvPosition = uMVMatrix * vec4(vertexPosition, 1.0);
    gl_Position = uPMatrix * mvPosition;
    if(vertexPosition.x *vertexPosition.x + vertexPosition.z *vertexPosition.z < 5) {
    	vColor = vec4(0.5, 0.0, 0.0, 0.5);
    }
    else if(vertexPosition.x *vertexPosition.x + vertexPosition.z *vertexPosition.z < 6.0) {
	vColor = vec4(0.5, 0.5, 0.0, 1.0);
    } else {
	vColor = vec4(0.9, 0.9, 0.0, 1.0);
    }
    transformedNormal = uNMatrix * vertexNormal;
    texCoord = vec2(textureCoord.x, 1.0 - textureCoord.y);
}
