/*------------------------------------------------*/
/* 07osvetleni/normals.c                          */

#include "ground.h"
#include <stdlib.h>
#include <time.h>

static void cn_free(const Ground * g)
{
    free(g->vertices);
    free(g->texCoord);
}


Ground generateGround(int cols, int rows, float width, float height, float upRatio) {
	Ground g;
	g.length = cols * rows * 18 * sizeof(GLfloat);
	g.vertices = (GLfloat *) malloc(g.length);
	g.free = cn_free;
	g.texLength = g.length *2 /3;
	g.texCoord = (GLfloat *) malloc(g.texLength);

	float xdelta = -cols * width/2.0;
	float zdelta = -rows * height/2.0;

	srand(time(NULL));
	int j,c;
	for(j = 0 ; j < rows; j++) {
		for (c =0; c < cols; c++) {
			g.vertices[cols*j*18+c*18 +0] = xdelta + width*c;
			if(c == 0 && j == 0) {
				g.vertices[cols*j*18+c*18 +1] = rand()/(float)RAND_MAX/upRatio;
			} else {
				g.vertices[cols*j*18+c*18 +1] = c == 0 ?g.vertices[cols*(j-1)*18+c*18 +13] : g.vertices[cols*j*18+(c-1)*18 +7];
			}
			g.vertices[cols*j*18+c*18 +2] = zdelta + height*j;

			g.vertices[cols*j*18+c*18 +3] = xdelta + width*(c+1);
			g.vertices[cols*j*18+c*18 +4] = rand()/(float)RAND_MAX/upRatio;
			g.vertices[cols*j*18+c*18 +5] = zdelta + height*(j+1);

			g.vertices[cols*j*18+c*18 +6] = xdelta + width*(c+1);
			g.vertices[cols*j*18+c*18 +7] = j == 0 ? rand()/(float)RAND_MAX/upRatio : g.vertices[cols*(j-1)*18+c*18 +16];
			g.vertices[cols*j*18+c*18 +8] = zdelta + height*j;
			//--
			g.vertices[cols*j*18+c*18 +9] = xdelta + width*c;
			g.vertices[cols*j*18+c*18 +10] = g.vertices[cols*j*18+c*18 +1];
			g.vertices[cols*j*18+c*18 +11] = zdelta + height*j;

			g.vertices[cols*j*18+c*18 +12] = xdelta + width*c;
			g.vertices[cols*j*18+c*18 +13] = c == 0 ? rand()/(float)RAND_MAX/upRatio: g.vertices[cols*j*18+(c-1)*18 +4];
			g.vertices[cols*j*18+c*18 +14] = zdelta + height*(j+1);

			g.vertices[cols*j*18+c*18 +15] = xdelta + width*(c+1);
			g.vertices[cols*j*18+c*18 +16] = g.vertices[cols*j*18+c*18 +4];
			g.vertices[cols*j*18+c*18 +17] = zdelta + height*(j+1);

			g.texCoord[cols*j*12+c*12 +0] = 0.0;
			g.texCoord[cols*j*12+c*12 +1] = 0.0;

			g.texCoord[cols*j*12+c*12 +2] = 1.0;
			g.texCoord[cols*j*12+c*12 +3] = 1.0;

			g.texCoord[cols*j*12+c*12 +4] = 1.0;
			g.texCoord[cols*j*12+c*12 +5] = 0.0;
			//--
			g.texCoord[cols*j*12+c*12 +6] = 0.0;
			g.texCoord[cols*j*12+c*12 +7] = 0.0;

			g.texCoord[cols*j*12+c*12 +8] = 0.0;
			g.texCoord[cols*j*12+c*12 +9] = 1.0;

			g.texCoord[cols*j*12+c*12 +10] = 1.0;
			g.texCoord[cols*j*12+c*12 +11] = 1.0;
		}
	}

	return g;
}
